Subject: Re: [PATCH] merge: add instructions to the commit message when editing

From: Junio C Hamano <[email-masked]>
Date: Mon, 30 Jan 2012 13:03:35 -0800

Thomas Rast <[email-masked]> writes:

> The sentence about justification is one of the few things about
> standard git that are not agnostic to the workflow that the user
> chose.

We try to be agnostic at plumbing level, but I do not think we ever made
such a promise at the Porcelain level like "git merge". On the contrary,
we try to encourage good workflows by coding behaviours to support BCP to
Porcelain commands.  Am I misreading what you were trying to say here?

> diff --git a/builtin/merge.c b/builtin/merge.c
> index bfb7547..ed628b8 100644
> --- a/builtin/merge.c
> +++ b/builtin/merge.c
> @@ -885,11 +885,22 @@ static void abort_commit(const char *err_msg)
>  	exit(1);
>  }
>  
> +static const char merge_editor_comment[] =
> +N_("Please enter the commit message for your merge commit.  You should\n"
> +"justify it especially if it merges an updated upstream into a topic\n"
> +"branch.\n"
> +"\n"
> +"Lines starting with '#' will be ignored, and an empty message aborts\n"
> +"the commit.\n");

I am tempted to rewrite this a bit, perhaps something like ...

  Please enter the commit message for your merge commit.  Explain
  why the merge is necessary, especially if it merges an updated
  upstream into a topic branch.

... because people who need to be told to "justify it" would probably be
helped by a more explicit "explain _why_ it is needed".